import java.util.*;

/**
 * Representation of a FeatFile Chunk
 *
 * @author Ron Weiss (ronw@ee.columbia.edu)
 */

public class FeatChunk extends Chunk
{
    private Vector features = null;

    /**
     * FeatChunk constructor
     */
    public FeatChunk(String sf, double st, double l)
    {
        super(sf, st, l);
        
        features = new Vector();
    }
   
    public void addFeature(Object[] f)
    {
        features.addAll(Arrays.asList(f));
    }

    public void addFeature(Vector f)
    {
        features.addAll(f);
    }

    // Java Fucking Sucks. why in gods name does the Double class need
    // to exist?  Why can't all instances of doubles in Object context
    // be automatically promoted to Doubles.  Why damnit why.
    public void addFeature(double[] f)
    {
        for(int i = 0; i < f.length; i++)
            features.add(new Double(f[i]));
    }

    public void addFeature(Object f)
    {
        features.add(f);
    }

    public void addFeature(double f)
    {
        features.add(new Double(f));
    }

    /**
     * Returns the number of features associated with this Chunk
     */
    public int numFeatures()
    {
        return features.size();
    }

    public double[] getFeatures()
    {
        double[] feats = new double[features.size()];

        for(int i = 0; i < feats.length; i++)
            feats[i] = ((Double)features.get(i)).doubleValue();

        return feats;
    }
    
    // get some features
    public double[] getFeatures(int[] idx)
    {
        if (idx == null)
            return getFeatures();

        double[] feats = new double[idx.length];

        for(int i = 0; i < idx.length; i++)
            feats[i] = ((Double)features.get(idx[i])).doubleValue();

        return feats;
    }

    /**
     * Write a description of this Chunk as a String in the format
     * expected in a FeatFile
     */
    public String toString()
    {
        // concatenating strings is super slow.  Better to use StringBuffer
        // guesstimate the string length
        StringBuffer s = new StringBuffer(20*features.size());
        s.append(srcFile).append(" ").append(startTime).append(" ").append(length).append(" ");

        if(features != null)
        {
            Iterator x = features.iterator();
            while(x.hasNext())
                    s.append(x.next()).append(" ");
        }

        s.append(comment).append("\n");
        
        return s.toString();
    }
}
