package featextractors;

/**
 * A really simple feature calculation that calculates the total power
 * in a chunk
 *
 * @author Ron Weiss (ronw@ee.columbia.edu)
 */

public class ChunkPower implements FeatureExtractor 
{
    public double[] features(STFT stft, long startFrame, int length) 
    {
        double[] power = new double[1];
        power[0] = 0;
        double[] samples = stft.getSamples(startFrame, startFrame+length);

        for(int i=0; i<samples.length; i++) 
            power[0] += samples[i]*samples[i];
        
        return power;
    }
}
